package mx.gob.imss.simo.enlaces.common.constant;

public class SQLConstants {

    private SQLConstants() {
    }

    /**
     * Informacion Complementaria
     */

    public static final String BUSCAR_SUBSISTEMA = "SELECT * FROM  SIC_SUBSISTEMA where CVE_SUBSISTEMA = ?";
    public static final String OBTENER_SUBSISTEMA_RCV = "SELECT * FROM  SIC_SUBSISTEMA_RCV WHERE CVE_SUBSISTEMA = ? AND CVE_RCV = ? AND IND_CAPTURA = 1";
    public static final String OBTENER_SUBSISTEMA_RCV_DATO = "SELECT * FROM  SIC_SUBSISTEMA_RCV_DATO WHERE CVE_SUBSISTEMA_RCV = ?";
    public static final String OBTENER_SUBSISTEMAS_CIERRE = "SELECT * FROM  SIT_CIERRE_SUBSISTEMA WHERE CVE_PRESUPUESTAL = ? AND CVE_PERIODO_IMSS = ? AND IND_CERRADO = 1";
    public static final String OBTENER_INFORMACION_COMPLEMENTARIA_DATO = "SELECT * FROM  SIT_INF_COMPLEMENTARIA_DATO WHERE CVE_SUBSISTEMA_RCV = ? AND CVE_PRESUPUESTAL = ? AND CVE_PERIODO_IMSS = ? AND CVE_DATO = ?";
    public static final String OBTENER_FORMULA_DATO = "SELECT * FROM  SIC_DATO_FORMULA WHERE CVE_SUBSISTEMA_RCV = ? AND CVE_DATO = ? AND FEC_BAJA IS NULL";
    public static final String GUARDAR_INFORMACION_COMPLEMENTARIA = "INSERT INTO  SIT_INF_COMPLEMENTARIA (CVE_SUBSISTEMA_RCV,CVE_PRESUPUESTAL,CVE_PERIODO_IMSS,NUM_CIFRA_CONTROL,FEC_CREACION,CVE_CAPTURISTA, REF_CVE_SUBSISTEMA, REF_CVE_RCV) VALUES (?,?,?,?,?,?,?,?)";
    public static final String GUARDAR_DATOS_INFORMACION_COMPLEMENTARIA = "INSERT INTO  SIT_INF_COMPLEMENTARIA_DATO (CVE_SUBSISTEMA_RCV, CVE_PRESUPUESTAL, CVE_PERIODO_IMSS, CVE_DATO, NUM_VALOR_DATO) VALUES (?,?,?,?,?)";
    public static final String BUSCAR_INFORMACION_EXISTENTE = "SELECT * FROM  SIT_INF_COMPLEMENTARIA WHERE CVE_SUBSISTEMA_RCV = ? AND CVE_PRESUPUESTAL = ? AND CVE_PERIODO_IMSS = ? AND REF_CVE_SUBSISTEMA = ? AND REF_CVE_RCV = ?";
    public static final String ACTUALIZAR_INFORMACION_COMPLEMENTARIA = "UPDATE  SIT_INF_COMPLEMENTARIA SET NUM_CIFRA_CONTROL = ?, FEC_ACTUALIZACION = ?, CVE_CAPTURISTA_ACTUALIZA = ? WHERE CVE_SUBSISTEMA_RCV = ? AND CVE_PRESUPUESTAL = ? AND CVE_PERIODO_IMSS = ?";
    public static final String ACTUALIZAR_DATOS_INFORMACION_COMPLEMENTARIA = "UPDATE  SIT_INF_COMPLEMENTARIA_DATO SET NUM_VALOR_DATO = ? WHERE CVE_SUBSISTEMA_RCV = ? AND CVE_PRESUPUESTAL = ? AND CVE_PERIODO_IMSS = ? AND CVE_DATO = ?";
    public static final String OBTENER_DATOS_INFORMACION_COMPLEMENTARIA = "SELECT * FROM  SIT_INF_COMPLEMENTARIA_DATO WHERE CVE_SUBSISTEMA_RCV = ? AND CVE_PRESUPUESTAL = ? AND CVE_PERIODO_IMSS = ?";
    public static final String CONSULTAR_INFORMACION_COMPLEMENTARIA_POR_SUBSISTEMA = "SELECT * FROM  SIT_INF_COMPLEMENTARIA WHERE CVE_PRESUPUESTAL = ? AND CVE_PERIODO_IMSS = ? AND REF_CVE_SUBSISTEMA = ? ";
    public static final String CONSULTAR_INFORMACION_COMPLEMENTARIA_POR_SUBSISTEMA_ASC = "SELECT * FROM  SIT_INF_COMPLEMENTARIA WHERE CVE_PRESUPUESTAL = ? AND CVE_PERIODO_IMSS = ? AND REF_CVE_SUBSISTEMA = ? ORDER BY CVE_SUBSISTEMA_RCV";
    public static final String CONSULTAR_INFORMACION_COMPLEMENTARIA_DATO_POR_SUBSISTEMA = "SELECT * FROM  SIT_INF_COMPLEMENTARIA_DATO WHERE CVE_PRESUPUESTAL = ? AND CVE_PERIODO_IMSS = ? AND CVE_SUBSISTEMA_RCV = ?";
    public static final String CONSULTAR_CANTIDAD_RCV_PARA_CIFRA_99 = "SELECT * FROM   SIC_SUBSISTEMA_RCV WHERE CVE_SUBSISTEMA = ? AND CVE_RCV = 99";
    public static final String OBTENER_TOTAL_RCV_CAPTURADOS_POR_SUBSISTEMA = "SELECT COUNT(CVE_SUBSISTEMA_RCV) FROM  SIT_INF_COMPLEMENTARIA WHERE REF_CVE_SUBSISTEMA = ? ";
    public static final String OBTENER_TOTAL_RCV_CAPTURADOS_POR_SUBSISTEMA_PERIODO = "SELECT COUNT(CVE_SUBSISTEMA_RCV) FROM  SIT_INF_COMPLEMENTARIA WHERE REF_CVE_SUBSISTEMA = ? AND CVE_PRESUPUESTAL = ? AND CVE_PERIODO_IMSS = ? AND NUM_CIFRA_CONTROL IS NOT NULL";
    public static final String OBTENER_CIFRA_CONTROL_POR_SUBSISTEMA = "SELECT * FROM  SIT_INF_COMPLEMENTARIA WHERE REF_CVE_SUBSISTEMA = ? AND CVE_PRESUPUESTAL = ? AND CVE_PERIODO_IMSS = ? AND REF_CVE_RCV != 99";
    public static final String GUARDAR_CIERRE_SUBSISTEMA = "INSERT INTO  SIT_CIERRE_SUBSISTEMA (CVE_PRESUPUESTAL, CVE_PERIODO_IMSS, CVE_SUBSISTEMA, REF_JUSTIFICACION, IND_CERRADO, FEC_CIERRE, CVE_CAPTURISTA, FEC_ACTUALIZACION, CVE_CAPTURISTA_ACTUALIZA) VALUES (?,?,?,?,?,?,?,?,?)";
    public static final String ACTUALIZAR_CIERRE_SUBSISTEMA = "UPDATE  SIT_CIERRE_SUBSISTEMA SET REF_JUSTIFICACION = ?, FEC_ACTUALIZACION = ?, CVE_CAPTURISTA_ACTUALIZA = ?, IND_CERRADO = 1 WHERE CVE_PRESUPUESTAL = ? AND CVE_PERIODO_IMSS = ? AND CVE_SUBSISTEMA = ?";
    public static final String BUSCAR_CIERRE_SUBSISTEMA_EXISTENTE = "SELECT * FROM  SIT_CIERRE_SUBSISTEMA WHERE CVE_PRESUPUESTAL = ? AND CVE_PERIODO_IMSS = ? AND CVE_SUBSISTEMA = ?";
    public static final String ABRIR_SUBSISTEMA = "UPDATE  SIT_CIERRE_SUBSISTEMA SET IND_CERRADO = 0, FEC_ACTUALIZACION = ?, CVE_CAPTURISTA_ACTUALIZA = ? WHERE CVE_PRESUPUESTAL = ? AND CVE_PERIODO_IMSS = ? AND CVE_SUBSISTEMA = ?";
    public static final String CONSULTAR_INFORMACION_COMPLEMENTARIA_POR_CIERRE = "SELECT * FROM  SIT_INF_COMPLEMENTARIA WHERE CVE_PRESUPUESTAL = ? AND CVE_PERIODO_IMSS = ? AND REF_CVE_SUBSISTEMA = ? AND REF_CVE_RCV = 99";
    
    //public static final String ACTUALIZAR_CIFRA_CONTROL_INFORMACION_COMPLEMENTARIA_POR_CIERRE = "UPDATE  SIT_INF_COMPLEMENTARIA SET NUM_CIFRA_CONTROL = null WHERE CVE_SUBSISTEMA_RCV = ? AND CVE_PRESUPUESTAL = ? AND CVE_PERIODO_IMSS = ?";
    //public static final String ACTUALIZAR_CIFRA_CONTROL_INFORMACION_COMPLEMENTARIA_DATO_POR_CIERRE = "UPDATE  SIT_INF_COMPLEMENTARIA_DATO SET NUM_VALOR_DATO = null WHERE CVE_SUBSISTEMA_RCV = ? AND CVE_PRESUPUESTAL = ? AND CVE_PERIODO_IMSS = ?";
    
    
    public static final String ACTUALIZAR_CIFRA_CONTROL_INFORMACION_COMPLEMENTARIA_POR_CIERRE = "DELETE FROM  SIT_INF_COMPLEMENTARIA WHERE CVE_SUBSISTEMA_RCV = ? AND CVE_PRESUPUESTAL = ? AND CVE_PERIODO_IMSS = ?";
    public static final String ACTUALIZAR_CIFRA_CONTROL_INFORMACION_COMPLEMENTARIA_DATO_POR_CIERRE = "DELETE FROM SIT_INF_COMPLEMENTARIA_DATO WHERE CVE_SUBSISTEMA_RCV = ? AND CVE_PRESUPUESTAL = ? AND CVE_PERIODO_IMSS = ?";
    
    
    public static final String CONSULTAR_TOTAL_SUBSISTEMAS_CERRADOS = "SELECT COUNT(CVE_SUBSISTEMA) FROM  SIT_CIERRE_SUBSISTEMA WHERE IND_CERRADO = 1";
    public static final String CONSULTAR_TOTAL_SUBSISTEMAS_CERRADOS_PRESUPUESTAL = "SELECT COUNT(CVE_SUBSISTEMA) FROM  SIT_CIERRE_SUBSISTEMA WHERE IND_CERRADO = 1 AND CVE_PERIODO_IMSS = ? AND CVE_PRESUPUESTAL = ?";
    public static final String COUNT_INFORMACION_COMPLEMENTARIA_POR_SUBSISTEMA = "SELECT COUNT(CVE_SUBSISTEMA_RCV) FROM  SIT_INF_COMPLEMENTARIA WHERE REF_CVE_SUBSISTEMA = ?  AND CVE_PRESUPUESTAL = ? AND CVE_PERIODO_IMSS = ?";
    public static final String ELIMINAR_INFORMACION_COMPLEMENTARIA_DATO = "DELETE FROM  SIT_INF_COMPLEMENTARIA_DATO WHERE CVE_SUBSISTEMA_RCV = ? AND CVE_PRESUPUESTAL = ? AND CVE_PERIODO_IMSS = ?";
    public static final String ELIMINAR_INFORMACION_COMPLEMENTARIA = "DELETE FROM  SIT_INF_COMPLEMENTARIA WHERE CVE_SUBSISTEMA_RCV = ? AND CVE_PRESUPUESTAL = ? AND CVE_PERIODO_IMSS = ?";
    public static final String GENERAR_PERIODO_OPERACION_SIGUIENTE = "INSERT INTO  SIT_PERIODO_OPERACION (CVE_PRESUPUESTAL, CVE_TIPO_CAPTURA, CVE_PERIODO_IMSS, IND_CERRADO, FEC_CIERRE, IND_ACTUAL, IND_MONITOREO) VALUES (?, ?, ?, ?, '', ?, ?)";
    public static final String ACTUALIZAR_INDICADOR_ACTUAL_PERIODO = "UPDATE  SIT_PERIODO_OPERACION O SET O.IND_CERRADO = 0, O.FEC_CIERRE = ?, O.IND_ACTUAL = 1 WHERE O.CVE_PRESUPUESTAL = ? AND O.CVE_TIPO_CAPTURA = ? AND O.CVE_PERIODO_IMSS = ?";

    public static final String BUSCAR_SIGUIENTE_PERIODO_IMSS = "SELECT * FROM  SIC_PERIODOS_IMSS SI WHERE SI.CVE_PERIODO_IMSS>? AND  rownum = 1";
    public static final String BUSCAR_PERIODO_ABIERTO = "SELECT * FROM  SIT_PERIODO_OPERACION WHERE CVE_PRESUPUESTAL = ? AND CVE_TIPO_CAPTURA = ? AND IND_ACTUAL = ?";
    public static final String BUSCAR_PERIODO_ABIERTO_NUEVO = "SELECT * FROM SIT_PERIODO_OPERACION WHERE CVE_PRESUPUESTAL = ? AND CVE_TIPO_CAPTURA = ? AND IND_CERRADO = 0 ORDER BY CVE_PERIODO_IMSS ASC FETCH FIRST 1 ROWS ONLY";
    
    public static final String ACTUALIZAR_INDICADOR_MONITOREO = "UPDATE  SIT_PERIODO_OPERACION SET IND_MONITOREO = 0 WHERE CVE_PRESUPUESTAL = ? AND CVE_TIPO_CAPTURA = ? AND CVE_PERIODO_IMSS = ?";
    public static final String COUNT_PERIODOS_MONITOREO = "SELECT COUNT(CVE_PERIODO_IMSS) FROM  SIT_PERIODO_OPERACION WHERE IND_MONITOREO = 1 AND IND_CERRADO = 0 AND CVE_PRESUPUESTAL = ? AND CVE_TIPO_CAPTURA = ?";
    public static final String OBTENER_DATO_POR_SUBSISTEMA_RCV = "SELECT * FROM  SIC_SUBSISTEMA_RCV_DATO SRD INNER JOIN  SIC_SUBSISTEMA_RCV SR ON SRD.CVE_SUBSISTEMA_RCV = SR.CVE_SUBSISTEMA_RCV WHERE SR.CVE_SUBSISTEMA = ? AND SR.CVE_RCV = ? AND SR.IND_CAPTURA = 1";
    
    /**
     * Servicios Subrogados
     */

    public static final String OBTENER_SERVICIO_SUBROGAR = "SELECT SS.CVE_SERVICIO_SUBROGAR, SS.DES_SERVICIO_SUBROGAR, GS.DES_GRUPO_SUBROGAR FROM SIC_SERVICIO_SUBROGAR SS INNER JOIN SIC_GRUPO_SUBROGAR GS ON SS.CVE_GRUPO_SUBROGAR = GS.CVE_GRUPO_SUBROGAR "
            + "WHERE CVE_SERVICIO_SUBROGAR = ? AND SS.FEC_BAJA IS NULL AND GS.FEC_BAJA IS NULL";
    public static final String GUARDAR_SERVICIO_SUBROGAR = "INSERT INTO SIT_SERVICIO_SUBROGADO(CVE_SERVICIO_SUBROGADO,REF_FOLIO_CONTRATO,CVE_PACIENTE,CVE_PRESUPUESTAL,CVE_TIPO_CONTRATO,CVE_TIPO_SERVICIO,CVE_MOTIVO_SUBROGACION,CVE_SERVICIO_SUBROGAR,NUM_CANTIDAD_EVENTO,NUM_COSTO_UNITARIO,CVE_MEDICO,FEC_SERVICIO,CVE_CAPTURISTA) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?)";

    public static final String OBTENER_CATALOGO_GRUPO_SUBROGADO = "SELECT CVE_GRUPO_SUBROGAR, DES_GRUPO_SUBROGAR FROM SIC_GRUPO_SUBROGAR WHERE CVE_GRUPO_SUBROGAR = ? AND FEC_BAJA IS NULL";

    public static final String OBTENER_PERIODO_ACTIVO = "SELECT * FROM SIT_PERIODO_OPERACION PO INNER JOIN SIC_PERIODOS_IMSS PI ON PI.CVE_PERIODO_IMSS = PO.CVE_PERIODO_IMSS "
            + "WHERE PO.CVE_PRESUPUESTAL = ? AND PO.CVE_TIPO_CAPTURA = ? AND TO_DATE(?, 'DD/MM/YYYY') BETWEEN PI.FEC_INICIAL AND PI.FEC_FINAL";

    public static final String OBTENER_SIGUIENTE_PERIODO_IMSS = "SELECT * FROM SIC_PERIODOS_IMSS WHERE CVE_PERIODO_IMSS > TO_NUMBER (?)";

    public static final String BUSCAR_PERIODO_OPERACION = "SELECT * FROM SIT_PERIODO_OPERACION WHERE CVE_PERIODO_IMSS = ? and CVE_TIPO_CAPTURA = ? AND CVE_PRESUPUESTAL = ?";

    public static final String ABRIR_NUEVO_PERIODO = "INSERT INTO SIT_PERIODO_OPERACION (CVE_PRESUPUESTAL, CVE_TIPO_CAPTURA, CVE_PERIODO_IMSS, IND_CERRADO, FEC_CIERRE, IND_ACTUAL, IND_MONITOREO)VALUES (?, ?, ?, 0, NULL, 0, 0)";

    public static final String ABRIR_PERIODO_NUEVO_SERVICIO_SUBROGAR = "UPDATE SIT_PERIODO_OPERACION O SET O.IND_CERRADO = 0, O.IND_ACTUAL=1 WHERE O.CVE_PRESUPUESTAL = ? AND O.CVE_TIPO_CAPTURA = ? AND O.CVE_PERIODO_IMSS = ?";
}
